<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">Menu Card component</div>

                    <div class="card-body">
                        <table class="table table-bordered table-striped">
                            <tr><th>Name</th><th>qtt</th><th>subtotal (Rp)</th></tr>
                            <tr v-for="item in order" :key="item.menu.id">
                                <td>{{item.menu.menu_name}}</td>
                                <td>{{item.count}}</td>
                                <td>{{toMoney(item.menu.price * item.count)}}</td>
                            </tr>
                        </table>
                        <div class="card-footer container">
                            <div class="row"><div class="btn btn-primary ">Rp. {{toMoney(totalPrice)}},-</div></div>
                            <div class="row" style="margin-top: 10px;">
                                <select class="form-control col-8" id="method" name="method" v-model="method" required>
                                    <option >-Select Payment Method-</option>
                                    <option value="bca">Transfer Bank - BCA</option>
                                    <option value="mandiri">Transfer Bank - Mandiri</option>
                                    <option value="bni">Transfer Bank - BNI</option>
                                    <option value="permata">Transfer Bank - Permata</option>
                                </select>
                                <div class="btn btn-success" @click="submit">Proceed</div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import BusEvent from '../../bus';

    export default {
        data(){
            return{
                order : [],
                method : ''
            }
        },
        computed:{
            totalPrice: function() {
                function sum(a){
                    let tot = 0
                    a.forEach(El=>{
                        tot += El.menu.price * El.count
                    })
                    return tot
                }
                return sum(this.order);
            }
        },
        methods: {
            add(item){
                let index = this.index(item)
                if(index == -1){
                    this.order.push({menu : item, count : 1})
                }else{
                    this.order[index].count++
                }
            },
            minus(item){
                let index = this.index(item)
                if(index !== -1){
                    this.order[index].count--
                    if(this.order[index].count == 0){
                        this.order = this.order.filter((i)=>{
                            return i.menu.id !== item.id
                        })
                    }
                }
            },
            index(menu){
                let res = -1;
                this.order.forEach((item, index) => {
                    if (menu.id === item.menu.id){
                        res = index
                    }
                });
                return res;
            },
            toMoney(num){
                if(num == 0 || num == null) return 0
                return num.toString().replace(/\B(?=(\d{3})+(?!\d))/g , ".")
            },
            submit(){
                axios.post('/proceed', {total_price : this.totalPrice, detail : this.order, method: this.method}).then(response=>{
                    if (response.status == 201){
                        this.order = []
                        alert('transaction completed')
                    }else{
                        alert('transaction failed, '+ response.statustext)
                    }
                });
            }
        },
        mounted() {
            BusEvent.$on('add', (menu)=>{
                this.add(menu)
            })
            BusEvent.$on('minus', (menu)=>{
                this.minus(menu)
            })
        }
    }
</script>
